; rcprn.asm
;
; (C)opyright (c) 31-Jul-2000, Przemyslaw Czerpak <druzus@polbox.com>
;
; last modyfication: 31-Jul-2000
; version: 0.1
;
;
; This program is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.
;
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
;

.8086
.MODEL TINY
.CODE

VERSION         EQU     "0.1"           ; Version

BUF_LEN         EQU     2000H           ; SPOOL BUFFER LENGTH
MIN_BUF		EQU	BUF_LEN / 4	;
DEF_LPT 	EQU	0       	; 0-LPT1, 1-LPT2, 2-LPT3
REP_CHK         EQU     20              ; REPEAT QUEUE CHECKING IN CLKS. (~18.21/SEC.)
CHAR_COUNT      EQU     REP_CHK * 50    ; NO OF CHARS PRINTED IN ONE INT.
;REP_CHK         EQU     0020H           ; REPEAT QUEUE CHECKING IN CLKS.
;CHAR_COUNT      EQU     0100H           ; NO OF CHARS PRINTED IN ONE INT.
STACK_LEN       EQU     0200H           ; INRENAL STACK SIZE
STACK_TOP       EQU     OFFSET BUFFER + BUF_LEN + STACK_LEN
RESID_END       EQU     STACK_TOP + 0FH
OPEN_MODE       EQU     00H             ; QUEUE-FILE OPEN MODE
MAX_BIND_NAME   EQU     30H             ; MAX BINDERY OBJECT NAME

		ORG	100H

                ASSUME  CS:@CODE, DS:@CODE, ES:@CODE
START:
                CALL    BEGIN

QUEUE_NAME      DB      MAX_BIND_NAME DUP (0)
QUEUE_ID        DD      0
ATTACHED        DB      0
JOB_NO          DW      0FFFFH
QFILE_HANDLE    DW      0FFFFH
QFILE_NAME      DB      "NETQ",0

DISK_BUSY       DW      0
INDOS_PTR	DW	0,0
CRITERR_PTR     DW      0,0
MY_PSP		DW	0
ANY_PSP		DW	0
MY_DTA		DW	0,0
ANY_DTA		DW	0,0
CRIT_FLAG       DB      0
BREAK_FLAG      DB      0
UNDER_0CH_FLAG  DB      0
OVER_0CH_FLAG   DB      0

DOSERR_AX       DW      0
DOSERR_BX       DW      0
DOSERR_CX       DW      0
DOSERR_DX       DW      0
DOSERR_SI       DW      0
DOSERR_DI       DW      0
DOSERR_DS       DW      0
DOSERR_ES       DW      0
                DW      0
                DW      0
DOSERR_PSP      DW      0

STACK_RET       DW      0
STACK_SS        DW      0
STACK_SP        DW      0

LPT_PORT	DW	DEF_LPT
COUNT		DW	0
L_PTR		DW	0
IN_IRQ		DB	0
INTERRUPT_NO    DB      0
READ_CLK        DW      REP_CHK

OLD_INT13       DW      0,0
OLD_INT17	DW	0,0
OLD_INT1B       DW      0,0
OLD_INT1C	DW	0,0
OLD_INT21       DW      0,0
OLD_INT23       DW      0,0
OLD_INT24       DW      0,0
OLD_INT28	DW	0,0

;***********************************************************
S_GTQID         DW      MAX_BIND_NAME + 3
                DB      35H
                DB      0,3
S_GTQID_LEN     DB      0
S_GTQID_NAME    DB      MAX_BIND_NAME DUP(0)
;**************
R_GTQID         DW      MAX_BIND_NAME + 6
R_GTQID_ID      DD      0
R_GTQID_TYPE    DW      0
R_GTQID_NAME    DB      MAX_BIND_NAME DUP(0)
;***********************************************************
S_ATQS          DW      05H
                DB      6FH
S_ATQS_QID      DD      0
;***********************************************************
S_DATQS         DW      05H
                DB      70H
S_DATQS_QID     DD      0
;***********************************************************
S_SQJB          DW      07H
                DB      71H
S_SQJB_QID      DD      0
S_SQJB_TYPE     DW      0FFFFH
;***************
R_SQJB          DW      36H
                DB      0
                DB      0
                DD      0
                DD      0
                DB      6 DUP(0)
                DB      6 DUP(0)
R_SQJB_JOBNO    DW      0
R_SQJB_JOBTYPE  DW      0
                DB      0
                DB      0
                DB      14 DUP(0)
R_SQJB_HANDLE   DB      6 DUP(0)
                DB      0
                DB      0
R_SQJB_QID      DD      0
;***********************************************************
S_ASQJB         DW      07H
                DB      73H
S_ASQJB_QID     DD      0
S_ASQJB_JOBNO   DW      0FFFFH
;***********************************************************
S_FSQJB         DW      07H
                DB      72H
S_FSQJB_QID     DD      0
S_FSQJB_JOBNO   DW      0FFFFH
;***********************************************************
R_EMPTY         DW      0
;***********************************************************

;******************************************************************************
; ds:si - queue name
; return:
;       clc - successful
;       stc - error
;             al - error code
;
GTQID           PROC    NEAR

                PUSH    SI
                PUSH    DI

                MOV     DI,OFFSET S_GTQID_NAME
                MOV     CX,MAX_BIND_NAME
                MOV     BX,CX
GTQID1:
                LODSB
                OR      AL,AL
                JZ      GTQID2
                CMP     AL,20H
                JBE     GTQID2
                STOSB
                LOOP    GTQID1
GTQID2:
                SUB     BX,CX
                MOV     BYTE PTR S_GTQID_LEN,BL

                MOV     SI,OFFSET S_GTQID
                MOV     DI,OFFSET R_GTQID

                CALL    NW_REQUEST
                JC      GTQID3

                MOV     AX,WORD PTR R_GTQID_ID[0]
                MOV     DX,WORD PTR R_GTQID_ID[2]
                MOV     WORD PTR QUEUE_ID[0],AX
                MOV     WORD PTR QUEUE_ID[2],DX
		OR	AX,DX
                JNZ     GTQID3
		STC
GTQID3:
                POP     DI
                POP     SI
                RET

GTQID           ENDP

;******************************************************************************
; return:
;       clc - successful
;       stc - error
;             al - error code
;
ATQS            PROC    NEAR

                PUSH    SI
                PUSH    DI

                MOV     AX,WORD PTR QUEUE_ID[0]
                MOV     DX,WORD PTR QUEUE_ID[2]
                MOV     WORD PTR S_ATQS_QID[0],AX
                MOV     WORD PTR S_ATQS_QID[2],DX

                MOV     SI,OFFSET S_ATQS
                MOV     DI,OFFSET R_EMPTY

                CALL    NW_REQUEST
                JC      ATQS1

                MOV     BYTE PTR ATTACHED,1
ATQS1:
                POP     DI
                POP     SI
                RET

ATQS            ENDP

;******************************************************************************
; return:
;       clc - successful
;       stc - error
;             al - error code
;
DATQS           PROC    NEAR

                PUSH    SI
                PUSH    DI

                CMP     BYTE PTR ATTACHED,0H
                JE      DATQS1

                MOV     AX,WORD PTR QUEUE_ID[0]
                MOV     DX,WORD PTR QUEUE_ID[2]
                MOV     WORD PTR S_DATQS_QID[0],AX
                MOV     WORD PTR S_DATQS_QID[2],DX

                OR      DX,AX
                JZ      DATQS1

                MOV     SI,OFFSET S_DATQS
                MOV     DI,OFFSET R_EMPTY

                CALL    NW_REQUEST
                JC      DATQS1

                MOV     BYTE PTR ATTACHED,0
DATQS1:
                POP     DI
                POP     SI
                RET

DATQS           ENDP

;******************************************************************************
; return:
;       clc - successful
;       stc - error
;             al - error code
;
SQJB            PROC    NEAR

                CMP     WORD PTR JOB_NO,0FFFFH
                JNE     SQJB2
                PUSH    SI
                PUSH    DI

                MOV     AX,WORD PTR QUEUE_ID[0]
                MOV     DX,WORD PTR QUEUE_ID[2]
                MOV     WORD PTR S_SQJB_QID[0],AX
                MOV     WORD PTR S_SQJB_QID[2],DX

                MOV     SI,OFFSET S_SQJB
                MOV     DI,OFFSET R_SQJB

                CALL    NW_REQUEST
                JC      SQJB1

                MOV     AX,WORD PTR R_SQJB_JOBNO
                MOV     WORD PTR JOB_NO,AX
SQJB1:
                POP     DI
                POP     SI
SQJB2:
                RET

SQJB            ENDP

;******************************************************************************
; return:
;       clc - successful
;       stc - error
;             al - error code
;
ASQJB           PROC    NEAR

                MOV     AX,WORD PTR JOB_NO
                CMP     AX,0FFFFH
                JZ      ASQJB1

                MOV     WORD PTR S_ASQJB_JOBNO[0],AX

                MOV     AX,WORD PTR QUEUE_ID[0]
                MOV     DX,WORD PTR QUEUE_ID[2]
                MOV     WORD PTR S_ASQJB_QID[0],AX
                MOV     WORD PTR S_ASQJB_QID[2],DX

                MOV     SI,OFFSET S_ASQJB
                MOV     DI,OFFSET R_EMPTY

                CALL    NW_REQUEST
                JC      ASQJB1

                MOV     WORD PTR JOB_NO,0FFFFH
ASQJB1:
                RET

ASQJB           ENDP

;******************************************************************************
; return:
;       clc - successful
;       stc - error
;             al - error code
;
FSQJB           PROC    NEAR

                MOV     AX,WORD PTR JOB_NO
                CMP     AX,0FFFFH
                JZ      FSQJB1

                MOV     WORD PTR S_FSQJB_JOBNO[0],AX

                MOV     AX,WORD PTR QUEUE_ID[0]
                MOV     DX,WORD PTR QUEUE_ID[2]
                MOV     WORD PTR S_FSQJB_QID[0],AX
                MOV     WORD PTR S_FSQJB_QID[2],DX

                MOV     SI,OFFSET S_FSQJB
                MOV     DI,OFFSET R_EMPTY

                CALL    NW_REQUEST
                JC      FSQJB1

                MOV     WORD PTR JOB_NO,0FFFFH
FSQJB1:
                RET

FSQJB           ENDP

;******************************************************************************
; return:
;       clc - successful
;       stc - error
;             al - error code
;
OPENQF          PROC    NEAR

                MOV     AX,3D00H + OPEN_MODE
                MOV     DX,OFFSET QFILE_NAME
                INT     21H
                JC      OPENQF1
                MOV     WORD PTR QFILE_HANDLE,AX
OPENQF1:
                RET

OPENQF          ENDP

;******************************************************************************
; return:
;       clc - successful
;       stc - error
;             al - error code
;
CLOSEQF         PROC    NEAR

                MOV     BX,WORD PTR QFILE_HANDLE
                CMP     BX,0FFFFH
                JE      CLOSEQF1
                MOV     AH,3EH
                INT     21H
                JC      CLOSEQF1
                MOV     WORD PTR QFILE_HANDLE,0FFFFH
CLOSEQF1:
                RET

CLOSEQF         ENDP

;******************************************************************************
OPENJOB         PROC    NEAR

                CALL    SQJB
                JC      OPENJOB2
                CALL    OPENQF
                JC      OPENJOB1
                RET
OPENJOB1:
                CALL    ASQJB
OPENJOB2:
                STC
                RET

OPENJOB         ENDP

;******************************************************************************
FINISHJOB       PROC    NEAR

                CALL    CLOSEQF
                CALL    FSQJB
                RET

FINISHJOB       ENDP

;******************************************************************************
ABORDJOB        PROC    NEAR

                CALL    CLOSEQF
                CALL    ASQJB
                RET

ABORDJOB        ENDP

;******************************************************************************
; ds:si - request buffer
; es:di - receive buffer
;
NW_REQUEST      PROC    NEAR

                MOV     AX,0E300H
                INT     21H
                OR      AL,AL
                JZ      NW_REQ1
                STC
NW_REQ1:
                RET

NW_REQUEST      ENDP

;****************************************************************************
INT13:
                PUSHF
                INC     WORD PTR CS:DISK_BUSY
                POPF
                PUSHF
                CALL    DWORD PTR CS:[OLD_INT13]
                PUSHF
                DEC     WORD PTR CS:DISK_BUSY
                POPF
                RETF    2

;****************************************************************************
INT24:
                MOV     BYTE PTR CS:CRIT_FLAG,0FFH
                MOV     AL,3
INT1B:
INT23:
                IRET
;****************************************************************************
INT21:
                STI
                CMP     AH,0H                           ; Function 0h uses second stack
                JZ      OVER_0CH

                CMP     AH,4BH                          ; EXEC requires special treatment
                JZ      FUNC_4BH

                CMP     AH,1AH
                JZ      REENT_FUNC
                CMP     AH,2FH
                JZ      REENT_FUNC
                CMP     AH,33H
                JZ      REENT_FUNC
                CMP     AH,34H
                JZ      REENT_FUNC
                CMP     AH,50H
                JZ      REENT_FUNC
                CMP     AH,51H
                JZ      REENT_FUNC

                CMP     AH,0CH
                JA      OVER_0CH
UNDER_0CH:
                MOV     BYTE PTR CS:UNDER_0CH_FLAG,0FFH
                PUSHF
                CALL    DWORD PTR CS:[OLD_INT21]
                MOV     BYTE PTR CS:UNDER_0CH_FLAG,00H
                JMP     SHORT INT21_SRV
OVER_0CH:
                MOV     BYTE PTR CS:OVER_0CH_FLAG,0FFH
                PUSHF
                CALL    DWORD PTR CS:[OLD_INT21]
                MOV     BYTE PTR CS:OVER_0CH_FLAG,00H
                JMP     SHORT INT21_SRV
FUNC_4BH:
                MOV     BYTE PTR CS:OVER_0CH_FLAG,0FFH
REENT_FUNC:
                JMP     DWORD PTR CS:[OLD_INT21]

INT21_SRV:
                PUSHF
                PUSH    AX
                PUSH    DS

		PUSH	CS
		POP	DS

		MOV	AL,1
                XCHG    AL,BYTE PTR IN_IRQ
		OR	AL,AL
                JNZ     INT21_EXIT

                CALL    CAN_SERVICE
                JC      INT21_SKIP2

                CALL    SET_STACK

                CALL    CAN_DOS
                JC      INT21_SKIP

                ;CALL    SERVICE
INT21_SKIP:
                CALL    RESTORE_STACK
INT21_SKIP2:
                MOV     BYTE PTR IN_IRQ,0
INT21_EXIT:
                POP     DS
                POP     AX
                POPF
                RETF    2

;****************************************************************************
INT1C:
                PUSHF
                STI
                PUSH    AX
                PUSH    DS

		PUSH	CS
		POP	DS

		MOV	AL,1
                XCHG    AL,BYTE PTR IN_IRQ
		OR	AL,AL
                JNZ     INT1C_EXIT

                TEST    WORD PTR READ_CLK,0FFFFH
                JZ      INT1C_CLK
                DEC     WORD PTR READ_CLK
INT1C_CLK:
; I can't make any save reenterant to DOS from 1Ch interrupt
; especialy under WIN9x DOS version.
; If you can let me know that and uncomment the part below.
;
;                CALL    CAN_SERVICE
;                JC      INT1C_SKIP2
;
;                CALL    SET_STACK
;
;                CALL    CAN_DOS
;                JC      INT1C_SKIP
;
;                CALL    SERVICE
;INT1C_SKIP:
;                CALL    RESTORE_STACK
;INT1C_SKIP2:
;
                MOV     BYTE PTR IN_IRQ,0
INT1C_EXIT:
                POP     DS
                POP     AX
		POPF
                JMP     DWORD PTR CS:[OLD_INT1C]
;****************************************************************************
INT28:
                PUSHF
                STI
                PUSH    AX
                PUSH    DS

		PUSH	CS
		POP	DS

		MOV	AL,1
                XCHG    AL,BYTE PTR IN_IRQ
		OR	AL,AL
                JNZ     INT28_EXIT

                CALL    CAN_SERVICE_28
                JC      INT28_SKIP2

                CALL    SET_STACK

                CALL    CAN_DOS_28
                JC      INT28_SKIP

                ;CALL    SERVICE
INT28_SKIP:
                CALL    RESTORE_STACK
INT28_SKIP2:
                MOV     BYTE PTR IN_IRQ,0
INT28_EXIT:
                POP     DS
                POP     AX
		POPF
                JMP     DWORD PTR CS:[OLD_INT28]
;****************************************************************************
SERVICE         PROC    NEAR
                CALL    SET_DOS
                CALL    READ
                CALL    PRINT
                CALL    REST_DOS
		RET
SERVICE         ENDP
;****************************************************************************
READ		PROC	NEAR

                TEST    WORD PTR READ_CLK,0FFFFH
                JNZ     READ_SKIP

                CMP     WORD PTR QFILE_HANDLE,0FFFFH
                JNE     READ_BUFCHK
                TEST    WORD PTR COUNT,0FFFFH
                JNZ     READ_EXIT
                CALL    OPENJOB
                CMP     WORD PTR QFILE_HANDLE,0FFFFH
                JE      READ_EXIT
READ_BUFCHK:
                MOV     CX,WORD PTR COUNT
		OR	CX,CX
                JZ      READ_BEG
		CMP	CX,MIN_BUF
                JAE     READ_EXIT
                MOV     AX,WORD PTR L_PTR
		OR	AX,AX
                JZ      READ_BEG
		MOV	DI,OFFSET BUFFER
		MOV	SI,DI
                ADD     SI,WORD PTR L_PTR
                CLD
	REP	MOVSB
READ_BEG:
                MOV     WORD PTR L_PTR,0

		MOV	AH,3FH
                MOV     BX,WORD PTR QFILE_HANDLE
		MOV	CX,BUF_LEN
                SUB     CX,WORD PTR COUNT
		MOV	DX,OFFSET BUFFER
                ADD     DX,WORD PTR COUNT
		INT	21H
                JC      READ_EXIT
                TEST    BYTE PTR CRIT_FLAG,0FFH
                JZ      READ_OK
READ_ERROR:
                CALL    ABORDJOB
                JMP     SHORT   READ_EXIT
READ_OK:
                ADD     COUNT,AX
                CMP     AX,CX
                JE      READ_EXIT
                CALL    FINISHJOB
READ_EXIT:
                MOV     WORD PTR READ_CLK,REP_CHK
READ_SKIP:
		RET
READ		ENDP
;****************************************************************************
PRINT           PROC    NEAR
                MOV     BX,WORD PTR COUNT
		OR	BX,BX
                JZ      PRINT_EXIT
                MOV     BYTE PTR CRIT_FLAG,00H
		MOV	CX,CHAR_COUNT	; NO OF CHARS PRINTED IN ONE INT.
		CMP	CX,BX
                JB      PRINT_LOOP
		MOV	CX,BX
PRINT_LOOP:
                MOV     BX,WORD PTR L_PTR
                MOV     AL,BYTE PTR BUFFER[BX]
                MOV     DX,WORD PTR LPT_PORT
		MOV	AH,00H
		PUSHF
                CALL    DWORD PTR [OLD_INT17]
		TEST	AH,101001B
                JNZ     PRINT_EXIT
                TEST    BYTE PTR CRIT_FLAG,0FFH         ; FOR NESTED REDIRECTORS
                JNZ     PRINT_EXIT
                INC     WORD PTR L_PTR
                DEC     WORD PTR COUNT
                LOOP    PRINT_LOOP
PRINT_EXIT:
		RET
PRINT		ENDP
;****************************************************************************
CAN_SERVICE     PROC    NEAR
                TEST    BYTE PTR UNDER_0CH_FLAG,0FFH
                JNZ     CANNOT_SRV
                TEST    BYTE PTR OVER_0CH_FLAG,0FFH
                JNZ     CANNOT_SRV
CAN_SERVICE_28:
                TEST    WORD PTR DISK_BUSY,0FFFFH
                JNZ     CANNOT_SRV
                TEST    WORD PTR READ_CLK,0FFFFH
                JZ      CAN_SRV
                TEST    WORD PTR COUNT,0FFFFH
                JNZ     CAN_SRV
CANNOT_SRV:
		STC
CAN_SRV:
		RET
CAN_SERVICE     ENDP
;****************************************************************************
CAN_DOS         PROC    NEAR
                XOR     AX,AX
                JMP     SHORT CAN_DOS_CHK
CAN_DOS_28:
                MOV     AL,1
CAN_DOS_CHK:
                PUSH    AX
                CALL    GET_INDOS
                POP     DX
                CMP     AL,DL
                JA      CANDOS_INDOS
		CALL	GET_ERRORMODE
		OR	AL,AL
                JZ      CANDOS_NOTIN
CANDOS_INDOS:
		STC
CANDOS_NOTIN:
		RET
CAN_DOS		ENDP
;****************************************************************************
GET_INDOS       PROC	NEAR
                PUSH    ES
                MOV     BX,WORD PTR INDOS_PTR[0]
                MOV     ES,WORD PTR INDOS_PTR[2]
		XOR	AX,AX
                MOV     AL,BYTE PTR ES:[BX]
                POP     ES
		RET
GET_INDOS	ENDP
;****************************************************************************
GET_ERRORMODE	PROC	NEAR
                PUSH    ES
                MOV     BX,WORD PTR CRITERR_PTR[0]
                MOV     ES,WORD PTR CRITERR_PTR[2]
		XOR	AX,AX
                MOV     AL,BYTE PTR ES:[BX]
                POP     ES
		RET
GET_ERRORMODE	ENDP
;****************************************************************************
SET_DOS		PROC	NEAR
		CALL	GET_PSP
                MOV     WORD PTR ANY_PSP,AX
		CALL	GET_DTA
                MOV     WORD PTR ANY_DTA[0],AX
                MOV     WORD PTR ANY_DTA[2],DX
                CALL    GET_BREAK
                MOV     BYTE PTR BREAK_FLAG,AL

                MOV     AX,WORD PTR MY_PSP
		CALL	SET_PSP
                MOV     AX,WORD PTR MY_DTA[0]
                MOV     DX,WORD PTR MY_DTA[2]
                CALL    SET_DTA
                XOR     AX,AX
                CALL    SET_BREAK
                CALL    SET_ERR_INF
                PUSH    ES
                MOV     AX,351BH
		INT	21H
                MOV     WORD PTR OLD_INT1B[0],BX
                MOV     WORD PTR OLD_INT1B[2],ES
                MOV     AX,3523H
		INT	21H
                MOV     WORD PTR OLD_INT23[0],BX
                MOV     WORD PTR OLD_INT23[2],ES
                MOV     AX,3524H
		INT	21H
                MOV     WORD PTR OLD_INT24[0],BX
                MOV     WORD PTR OLD_INT24[2],ES
                POP     ES
                MOV     DX,OFFSET INT1B
                MOV     AX,251BH
                INT     21H
                MOV     DX,OFFSET INT23
                MOV     AX,2523H
                INT     21H
                MOV     DX,OFFSET INT24
                MOV     AX,2524H
                INT     21H
                MOV     BYTE PTR CRIT_FLAG,00H
		RET
SET_DOS		ENDP
;****************************************************************************
REST_DOS	PROC	NEAR
                PUSH    DS
                MOV     DX,WORD PTR OLD_INT24[0]
                MOV     AX,WORD PTR OLD_INT24[2]
                MOV     DS,AX
                MOV     AX,2524H
                INT     21H
                POP     DS
                PUSH    DS
                MOV     DX,WORD PTR OLD_INT23[0]
                MOV     AX,WORD PTR OLD_INT23[2]
                MOV     DS,AX
                MOV     AX,2523H
                INT     21H
                POP     DS
                PUSH    DS
                MOV     DX,WORD PTR OLD_INT1B[0]
                MOV     AX,WORD PTR OLD_INT1B[2]
                MOV     DS,AX
                MOV     AX,251BH
                INT     21H
                POP     DS
                MOV     AL,BYTE PTR BREAK_FLAG
                CALL    REST_ERR_INF
                CALL    SET_BREAK
                MOV     AX,WORD PTR ANY_DTA[0]
                MOV     DX,WORD PTR ANY_DTA[2]
		CALL	SET_DTA
                MOV     AX,WORD PTR ANY_PSP
		CALL	SET_PSP
		RET
REST_DOS	ENDP
;****************************************************************************
SET_ERR_INF     PROC    NEAR
                PUSH    ES
                PUSH    DS
                MOV     AH,59H
                XOR     BX,BX
                INT     21H
                MOV     WORD PTR CS:DOSERR_DS,DS
                POP     DS
                MOV     WORD PTR DOSERR_AX,AX
                MOV     WORD PTR DOSERR_BX,BX
                MOV     WORD PTR DOSERR_CX,CX
                MOV     WORD PTR DOSERR_DX,DX
                MOV     WORD PTR DOSERR_SI,SI
                MOV     WORD PTR DOSERR_DI,DI
                MOV     WORD PTR DOSERR_ES,ES
                POP     ES
                RET
SET_ERR_INF     ENDP
;****************************************************************************
REST_ERR_INF    PROC    NEAR
                MOV     AX,WORD PTR ANY_PSP
                MOV     WORD PTR DOSERR_PSP,AX
                MOV     AX,5D0AH
                MOV     DX,OFFSET DOSERR_AX
                INT     21H
                RET
REST_ERR_INF    ENDP
;****************************************************************************
GET_PSP		PROC	NEAR
		MOV	AH,51H
		INT	21H
		MOV	AX,BX
		RET
GET_PSP		ENDP
;****************************************************************************
SET_PSP		PROC	NEAR
		MOV	BX,AX
		MOV	AH,50H
		INT	21H
		RET
SET_PSP		ENDP
;****************************************************************************
GET_DTA		PROC	NEAR
                PUSH    ES
		MOV	AH,2FH
	       	INT	21H
	       	MOV	AX,BX
       		MOV	DX,ES
                POP     ES
		RET
GET_DTA		ENDP
;****************************************************************************
SET_DTA		PROC	NEAR
		PUSH	DS
		MOV	DS,DX
		MOV	DX,AX
		MOV	AH,1AH
		INT	21H
		POP	DS
		RET
SET_DTA		ENDP
;****************************************************************************
GET_BREAK       PROC    NEAR
                MOV     AX,3300H
		INT	21H
                MOV     AX,DX
		RET
GET_BREAK       ENDP
;****************************************************************************
SET_BREAK       PROC    NEAR
                MOV     DX,AX
                MOV     AX,3301H
		INT	21H
		RET
SET_BREAK       ENDP
;****************************************************************************
SET_STACK       PROC    NEAR
                CLI
                POP     WORD PTR [STACK_RET]
                MOV     WORD PTR [STACK_SS],SS
                MOV     WORD PTR [STACK_SP],SP
                MOV     AX,CS
                MOV     SS,AX
                MOV     SP,STACK_TOP
                PUSH    BX
                PUSH    CX
                PUSH    DX
                PUSH    SI
                PUSH    DI
                PUSH    BP
                PUSH    ES
                PUSH    WORD PTR [STACK_RET]
                STI
                PUSH    CS
                POP     ES
                RET
SET_STACK       ENDP
;****************************************************************************
RESTORE_STACK   PROC    NEAR
                CLI
                POP     WORD PTR [STACK_RET]
                POP     ES
                POP     BP
                POP     DI
                POP     SI
                POP     DX
                POP     CX
                POP     BX
                MOV     SS,WORD PTR [STACK_SS]
                MOV     SP,WORD PTR [STACK_SP]
                PUSH    WORD PTR [STACK_RET]
                STI
                RET
RESTORE_STACK   ENDP
;******************************************************************************

BUFFER		DB	0

;****************************************************************************
STORE_DOS       PROC    NEAR
                PUSH    ES
		MOV	AH,34H
		INT	21H
		MOV	AX,ES
                MOV     WORD PTR INDOS_PTR[0],BX
                MOV     WORD PTR INDOS_PTR[2],AX
                PUSH    DS
                MOV     AX,5D06H
                INT     21H
                MOV     DX,DS
                POP     DS
                MOV     WORD PTR CRITERR_PTR[0],SI
                MOV     WORD PTR CRITERR_PTR[2],DX
		CALL	GET_PSP
                MOV     WORD PTR MY_PSP,AX
		CALL	GET_DTA
                MOV     WORD PTR MY_DTA[0],AX
                MOV     WORD PTR MY_DTA[2],DX
                POP     ES
                RET
STORE_DOS       ENDP
;******************************************************************************
DISP_ERROR      PROC    NEAR

                OR      DX,DX
                JZ      ERR0
                PUSH    AX
		MOV	AH,09H
		INT	21H
                POP     AX
ERR0:
                XOR     AH,AH
                MOV     BL,10H
                DIV     BL
                CMP     AL,09H
                JBE     ERR1
                ADD     AL,07H
ERR1:
                CMP     AH,09H
                JBE     ERR2
                ADD     AH,07H
ERR2:
                ADD     AX,3030H
                MOV     WORD PTR ERROR_NO,AX
		MOV	AH,09H
                MOV     DX,OFFSET MSG_ERROR
		INT	21H
                RET

DISP_ERROR      ENDP
;******************************************************************************
DISP_MSG        PROC    NEAR
		MOV	AH,09H
		INT	21H
                RET
DISP_MSG        ENDP
;******************************************************************************
PARSE_PARAM     PROC    NEAR
                MOV     DI,OFFSET QUEUE_NAME
                MOV     SI,081H
                XOR     CX,CX
                MOV     CL,BYTE PTR DS:[080H]
PARSE_LAB1:
                JCXZ    PARSE_ERROR
                LODSB
                DEC     CX
		CMP	AL,20H
                JB      PARSE_ERROR
                JE      PARSE_LAB1
                INC     CX
                CMP     CX,MAX_BIND_NAME
                JBE     PARSE_LAB2
                MOV     CX,MAX_BIND_NAME
PARSE_LAB2:
                STOSB
		LODSB
		CMP	AL,20H
                JBE     PARSE_LAB3
                LOOP    PARSE_LAB2
PARSE_LAB3:
                PUSH    AX
		XOR	AL,AL
                STOSB
                POP     AX
		CMP	AL,20H
                JB      PARSE_NOLPT
PARSE_LAB4:
		LODSB
		CMP	AL,20H
                JB      PARSE_NOLPT
                JE      PARSE_LAB4
                CMP     AL,031H
                JB      PARSE_ERROR
                CMP     AL,033H
                JA      PARSE_ERROR
                DEC     AX
                AND     AX,0FH
                MOV     DX,AX
                LODSB
		CMP	AL,20H
                JA      PARSE_ERROR
                MOV     WORD PTR LPT_PORT,DX
PARSE_NOLPT:
		CLC
		RET
PARSE_ERROR:
		STC
		RET
PARSE_PARAM     ENDP
;******************************************************************************
SET_INTERUPT    PROC    NEAR
                PUSH    ES
                MOV     AX,3513H
		INT	21H
                MOV     WORD PTR OLD_INT13[0],BX
                MOV     WORD PTR OLD_INT13[2],ES
                MOV     DX,OFFSET INT13
                MOV     AX,2513H
		INT	21H

		MOV	AX,3517H
		INT	21H
                MOV     WORD PTR OLD_INT17[0],BX
                MOV     WORD PTR OLD_INT17[2],ES

		MOV	AX,351CH
		INT	21H
                MOV     WORD PTR OLD_INT1C[0],BX
                MOV     WORD PTR OLD_INT1C[2],ES
		MOV	DX,OFFSET INT1C
		MOV	AX,251CH
		INT	21H

		MOV	AX,3528H
		INT	21H
                MOV     WORD PTR OLD_INT28[0],BX
                MOV     WORD PTR OLD_INT28[2],ES
		MOV	DX,OFFSET INT28
		MOV	AX,2528H
                INT     21H

                MOV     AX,3521H
		INT	21H
                MOV     WORD PTR OLD_INT21[0],BX
                MOV     WORD PTR OLD_INT21[2],ES
                MOV     DX,OFFSET INT21
                MOV     AX,2521H
                INT     21H
                POP     ES
		RET
SET_INTERUPT    ENDP
;******************************************************************************
BEGIN           PROC    NEAR
		PUSH	CS
                POP     DS
		PUSH	CS
                POP     ES

                MOV     DX,OFFSET MSG_BEGIN
                CALL    DISP_MSG

                CALL    PARSE_PARAM
                JC      BEG_SYNTAX

                MOV     SI, OFFSET QUEUE_NAME
                MOV     DI, OFFSET MSQ_QNAME
                MOV     CX,MAX_BIND_NAME
BEG_LAB1:
                LODSB
                OR      AL,AL
                JZ      BEG_LAB2
                STOSB
                LOOP    BEG_LAB1
BEG_LAB2:
                MOV     AX,LPT_PORT
                INC     AX
                OR      AL,030H
                MOV     BYTE PTR MSG_LPTNO,AL
                MOV     DX,OFFSET MSG_QUEUE
                CALL    DISP_MSG

                MOV     SI,OFFSET QUEUE_NAME
                CALL    GTQID
                JC      BEG_NOTFOUND

                MOV     DX,OFFSET MSG_FOUND
                CALL    DISP_MSG

                CALL    ATQS
                JC      BEG_NOTATT

		CALL	STORE_DOS
                CALL    SET_INTERUPT

                MOV     ES,WORD PTR CS:[002CH]
                MOV     AH,49H
                INT     21H

                MOV     DX,RESID_END
                MOV     CL,4
                SHR     DX,CL
		MOV	AX,3100H
                INT     21H
BEG_NOTATT:
                MOV     DX,OFFSET MSG_ATTACH
                JMP     SHORT   BEG_ERRNO
BEG_NOTFOUND:
                MOV     DX,OFFSET MSG_NOTFOUND
BEG_ERRNO:
                PUSH    AX
                CALL    DISP_MSG
                POP     AX
                XOR     DX,DX
                CALL    DISP_ERROR
                JMP     SHORT   BEG_EXIT
BEG_SYNTAX:
                MOV     DX,OFFSET MSG_SYNTAX
                CALL    DISP_MSG
BEG_EXIT:
                MOV     AX,4C01H
		INT	21H
BEGIN           ENDP
;******************************************************************************

MSG_BEGIN       DB      "Remote Connected Printer  ver. ",VERSION, 0DH, 0AH
                DB      "Simple resident DOS queue service for MARS_NWE or NOVELL.", 0DH, 0AH
                DB      "(c) RC-SOFT s.c. Przemyslaw Czerpak <druzus@polbox.com>", 0DH, 0AH
                DB      "This program is free software under the terms of the", 0DH, 0AH
                DB      "GNU General Public License", 0DH, 0AH, 0DH, 0AH,"$"
MSG_QUEUE       DB      "Queue "
MSQ_QNAME       DB      MAX_BIND_NAME + 1 DUP ('$')
MSG_NOTFOUND    DB      " not found - $"
MSG_FOUND       DB      " found, output to LPT"
MSG_LPTNO       DB      0, 0DH, 0AH, "$"
MSG_SYNTAX      DB      0DH, 0AH, "Usage:",09H,"rcprn QUEUE_NAME [LPT_NO]", 0DH, 0AH
                DB      "eg.:",09H,"rcprn LP_PS 2", 0DH, 0AH, "$"
MSG_NOQUEUE     DB      "Can't find queue - $"
MSG_ATTACH      DB      "Can't attach to server - $"
MSG_ERROR       DB      "error: "
ERROR_NO        DB      0, 0, "h", 0DH, 0AH, "$"

;******************************************************************************

END		START
